{----------------------------------------------------------------------------
|
| Module: AddMemFm.Pas
|
| Description: Form to add an index for the ClassGen wizard.
|
| History:       , 1998. MB first version.
|
|---------------------------------------------------------------------------}
unit AddIdxFm;

interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Mask, ExtCtrls;

type
  TAddIndexForm = class(TForm)
    OkBtn: TBitBtn;
    CancelBtn: TBitBtn;
    IndexNameEdit: TEdit;
    IndexNameLbl: TLabel;
    AttributesGB: TGroupBox;
    PrimaryCB: TCheckBox;
    UniqueCB: TCheckBox;
    DescendingCB: TCheckBox;
    CaseInsensitiveCB: TCheckBox;
    FieldsLbl: TLabel;
    FieldsLB: TListBox;
    IndexFieldsLbl: TLabel;
    IndexFieldsLB: TListBox;
    AddFieldBtn: TBitBtn;
    RemoveFieldBtn: TBitBtn;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure AddFieldBtnClick(Sender: TObject);
    procedure RemoveFieldBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AddIndexForm: TAddIndexForm;

implementation

{$R *.DFM}

uses
    OdbField; { for oftXXXX }


procedure TAddIndexForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
    if (ModalResult = mrOk) then
    begin
       if (IndexNameEdit.Text = '') then
       begin
            CanClose := False;
            MessageDlg( 'The index must have a name.', mtError, [mbOk], 0);
            Exit;
       end;

       if (IndexFieldsLB.Items.Count = 0) then
       begin
          CanClose := False;
          MessageDlg( 'The index field list is empty.',
                       mtError, [mbOk], 0);
       end;
    end;
end;

procedure TAddIndexForm.AddFieldBtnClick(Sender: TObject);
begin
    if FieldsLB.ItemIndex >= 0 then
    begin
        IndexFieldsLB.Items.Add( FieldsLB.Items[FieldsLB.ItemIndex] );
        FieldsLB.Items.Delete(FieldsLB.ItemIndex);
    end;
end;

procedure TAddIndexForm.RemoveFieldBtnClick(Sender: TObject);
begin
    if IndexFieldsLB.ItemIndex >= 0 then
    begin
        FieldsLB.Items.Add( IndexFieldsLB.Items[IndexFieldsLB.ItemIndex] );
        IndexFieldsLB.Items.Delete( IndexFieldsLB.ItemIndex );
    end;
end;

end.
